# -*- coding: utf-8 -*-
import re, subprocess, argparse
from prometheus_client import CollectorRegistry, Counter, write_to_textfile

#Configuration
from config import *

def export():
    # Parse Arguments
    parser = argparse.ArgumentParser(description='Script for exporting fail2ban-client metrics.')
    parser.add_argument('-j', '--jail', help="Jail name to be exported", required=True)
    parser.add_argument('-f', '--file', help="File to be saved. path + name", required=True )
    args=parser.parse_args()

    #Execute fail2ban-client for jail, parse the response and write to disk
    if args.jail is not None:
        registry  = CollectorRegistry()
        process   = subprocess.Popen(['fail2ban-client', 'status', args.jail], stdout=subprocess.PIPE)
        response  = process.communicate()[0]
        response = re.sub(r'(\\t)', '', response)
        response = re.sub(r'[^ A-Za-z0-9:./\n]', '', response)
        # Parse all
        for line in (response.splitlines()):
            if (':' in line):
                tmpLine = line.lstrip().split(':')
                if tmpLine[0] in parseKeys:
                    counter = Counter(parseKeys[tmpLine[0]][0], parseKeys[tmpLine[0]][1], ['jail'], registry=registry)
                    counter.labels(args.jail).inc(float(tmpLine[1]))
        write_to_textfile((args.file or (EXPORT_LOCATION + EXPORT_FILE_NAME)).replace('{{jail}}', args.jail), registry)
